Index: /XIOS/dev/dev_olga/src/node/field.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/field.cpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/node/field.cpp	(revision 1021)
@@ -36,5 +36,5 @@
       , domAxisScalarIds_(vector<StdString>(3,"")), areAllReferenceSolved(false), isReferenceSolved(false)
       , useCompressedOutput(false)
-      , isReadDataRequestPending(false)
+      , wasDataAlreadyReceivedFromServer(false)
    { setVirtualVariableGroup(CVariableGroup::create(getId() + "_virtual_variable_group")); }
 
@@ -47,5 +47,5 @@
       , domAxisScalarIds_(vector<StdString>(3,"")), areAllReferenceSolved(false), isReferenceSolved(false)
       , useCompressedOutput(false)
-      , isReadDataRequestPending(false)
+      , wasDataAlreadyReceivedFromServer(false)
    { setVirtualVariableGroup(CVariableGroup::create(getId() + "_virtual_variable_group")); }
 
@@ -179,10 +179,7 @@
   }
 
-  void CField::sendUpdateData(const CArray<double,1>& data, const int srvPool)
+  void CField::sendUpdateData(const CArray<double,1>& data, CContextClient* client)
   {
     CTimer::get("XIOS Send Data").resume();
-
-    CContext* context = CContext::getCurrent();
-    CContextClient* client = context->clientPrimServer[srvPool];
 
     CEventClient event(getType(), EVENT_ID_UPDATE_DATA);
@@ -312,5 +309,5 @@
         int fileIdx = std::find(context->enabledFiles.begin(), context->enabledFiles.end(), this->file) - context->enabledFiles.begin();
         int srvId = fileIdx % context->clientPrimServer.size();
-        sendUpdateData(fieldData, srvId);
+        sendUpdateData(fieldData, context->clientPrimServer[srvId]);
     }
     if (!context->hasClient && context->hasServer)
@@ -348,11 +345,10 @@
   }
 
-  void CField::sendReadDataRequest(void)
+  void CField::sendReadDataRequest(const CDate& tsDataRequested)
   {
     CContext* context = CContext::getCurrent();
     CContextClient* client = context->client;
 
-    lastDataRequestedFromServer = context->getCalendar()->getCurrentDate();
-    isReadDataRequestPending = true;
+    lastDataRequestedFromServer = tsDataRequested;
 
     CEventClient event(getType(), EVENT_ID_READ_DATA);
@@ -377,17 +373,17 @@
     const CDate& currentDate = CContext::getCurrent()->getCalendar()->getCurrentDate();
 
-    bool requestData = (currentDate >= lastDataRequestedFromServer + file->output_freq.getValue());
-
-    if (requestData)
-    {
-      cout<<"currentDate : "<<currentDate<<endl ;
-      cout<<"lastDataRequestedFromServer : "<<lastDataRequestedFromServer<<endl ;
-      cout<<"file->output_freq.getValue() : "<<file->output_freq.getValue()<<endl ;
-      cout<<"lastDataRequestedFromServer + file->output_freq.getValue() : "<<lastDataRequestedFromServer + file->output_freq.getValue()<<endl ;
-
-      sendReadDataRequest();
-    }
-
-    return requestData;
+    bool dataRequested = false;
+    while (currentDate >= lastDataRequestedFromServer)
+    {
+      info(20) << "currentDate : " << currentDate << endl ;
+      info(20) << "lastDataRequestedFromServer : " << lastDataRequestedFromServer << endl ;
+      info(20) << "file->output_freq.getValue() : " << file->output_freq.getValue() << endl ;
+      info(20) << "lastDataRequestedFromServer + file->output_freq.getValue() : " << lastDataRequestedFromServer + file->output_freq << endl ;
+
+      sendReadDataRequest(lastDataRequestedFromServer + file->output_freq);
+
+      dataRequested = true;
+    }
+    return dataRequested;
   }
 
@@ -411,16 +407,74 @@
 
     map<int, CArray<double,1> >::iterator it;
-    for (it = data_srv.begin(); it != data_srv.end(); it++)
-    {
-      msgs.push_back(CMessage());
-      CMessage& msg = msgs.back();
-      msg << getId();
-      if (hasData)
-        msg << getNStep() - 1 << it->second;
-      else
-        msg << int(-1);
-      event.push(it->first, grid->nbSenders[it->first], msg);
-    }
-    client->sendEvent(event);
+//    for (it = data_srv.begin(); it != data_srv.end(); it++)
+//    {
+//      msgs.push_back(CMessage());
+//      CMessage& msg = msgs.back();
+//      msg << getId();
+//      if (hasData)
+//        msg << getNStep() - 1 << it->second;
+//      else
+//        msg << int(-1);
+//      event.push(it->first, grid->nbSenders[it->first], msg);
+//    }
+//    client->sendEvent(event);
+    if (!grid->doGridHaveDataDistributed())
+    {
+       if (client->isServerLeader())
+       {
+          if (!data_srv.empty())
+          {
+            it = data_srv.begin();
+            const std::list<int>& ranks = client->getRanksServerLeader();
+            for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+            {
+              msgs.push_back(CMessage());
+              CMessage& msg = msgs.back();
+              msg << getId();
+              if (hasData)
+                msg << getNStep() - 1 << it->second;
+              else
+                msg << int(-1);
+              event.push(*itRank, 1, msg);
+            }
+          }
+          client->sendEvent(event);
+       }
+       else
+       {
+          // if (!data_srv.empty())
+          // {
+          //   it = data_srv.begin();
+          //   const std::list<int>& ranks = client->getRanksServerNotLeader();
+          //   for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+          //   {
+          //     msgs.push_back(CMessage());
+          //     CMessage& msg = msgs.back();
+          //     msg << getId();
+          //     if (hasData)
+          //       msg << getNStep() - 1 << it->second;
+          //     else
+          //       msg << int(-1);
+          //     event.push(*itRank, 1, msg);
+          //   }
+          // }
+          client->sendEvent(event);
+       }
+    }
+    else
+    {
+      for (it = data_srv.begin(); it != data_srv.end(); it++)
+      {
+        msgs.push_back(CMessage());
+        CMessage& msg = msgs.back();
+        msg << getId();
+        if (hasData)
+          msg << getNStep() - 1 << it->second;
+        else
+          msg << int(-1);
+        event.push(it->first, grid->nbSenders[it->first], msg);
+      }
+      client->sendEvent(event);
+    }
   }
 
@@ -494,10 +548,16 @@
     }
 
+    if (wasDataAlreadyReceivedFromServer)
+      lastDataReceivedFromServer = lastDataReceivedFromServer + file->output_freq;
+    else
+    {
+      lastDataReceivedFromServer = context->getCalendar()->getInitDate();
+      wasDataAlreadyReceivedFromServer = true;
+    }
+
     if (isEOF)
-      serverSourceFilter->signalEndOfStream(lastDataRequestedFromServer);
+      serverSourceFilter->signalEndOfStream(lastDataReceivedFromServer);
     else
-      serverSourceFilter->streamDataFromServer(lastDataRequestedFromServer, data);
-
-    isReadDataRequestPending = false;
+      serverSourceFilter->streamDataFromServer(lastDataReceivedFromServer, data);
   }
 
@@ -749,5 +809,5 @@
      solveGridDomainAxisRef(doSending2Server);
 
-     if (context->hasClient && !context->hasClient)
+     if (context->hasClient && !context->hasServer)
      {
        solveTransformedGrid();
@@ -831,8 +891,25 @@
      {
        // Check if we have an expression to parse
-       if (!content.empty())
-       {
-         boost::scoped_ptr<IFilterExprNode> expr(parseExpr(content + '\0'));
-         instantDataFilter = expr->reduce(gc, *this);
+       if (hasExpression())
+       {
+         boost::scoped_ptr<IFilterExprNode> expr(parseExpr(getExpression() + '\0'));
+         boost::shared_ptr<COutputPin> filter = expr->reduce(gc, *this);
+
+         // Check if a spatial transformation is needed
+         if (!field_ref.isEmpty())
+         {
+           CGrid* gridRef = CField::get(field_ref)->grid;
+
+           if (grid && grid != gridRef && grid->hasTransform())
+           {
+             double defaultValue = !default_value.isEmpty() ? default_value : 0.0;
+             std::pair<boost::shared_ptr<CFilter>, boost::shared_ptr<CFilter> > filters = CSpatialTransformFilter::buildFilterGraph(gc, gridRef, grid, defaultValue);
+
+             filter->connectOutput(filters.first, 0);
+             filter = filters.second;
+           }
+         }
+
+         instantDataFilter = filter;
        }
        // Check if we have a reference on another field
@@ -841,8 +918,9 @@
        // Check if the data is to be read from a file
        else if (file && !file->mode.isEmpty() && file->mode == CFile::mode_attr::read)
-         instantDataFilter = serverSourceFilter = boost::shared_ptr<CSourceFilter>(new CSourceFilter(grid,
-                                                                                                     freq_offset.isEmpty() ? NoneDu : freq_offset));
+         instantDataFilter = serverSourceFilter = boost::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid,
+                                                                                                     freq_offset.isEmpty() ? NoneDu : freq_offset,
+                                                                                                     true));
        else // The data might be passed from the model
-         instantDataFilter = clientSourceFilter = boost::shared_ptr<CSourceFilter>(new CSourceFilter(grid));
+         instantDataFilter = clientSourceFilter = boost::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid));
      }
 
@@ -863,4 +941,5 @@
      }
    }
+
 
    /*!
@@ -871,29 +950,27 @@
     * \return the output pin corresponding to the field reference
     */
-   boost::shared_ptr<COutputPin> CField::getFieldReference(CGarbageCollector& gc)
-   {
-     if (instantDataFilter || field_ref.isEmpty())
-       ERROR("COutputPin* CField::getFieldReference(CGarbageCollector& gc)",
-             "Impossible to get the field reference for a field which has already been parsed or which does not have a field_ref.");
-
-     CField* fieldRef = CField::get(field_ref);
-     fieldRef->buildFilterGraph(gc, false);
-
-     std::pair<boost::shared_ptr<CFilter>, boost::shared_ptr<CFilter> > filters;
-     // Check if a spatial transformation is needed
-     if (grid && grid != fieldRef->grid && grid->hasTransform())
-     {
-       double defaultValue = 0.0;
-       if (!default_value.isEmpty()) defaultValue = this->default_value;
-       filters = CSpatialTransformFilter::buildFilterGraph(gc, fieldRef->grid, grid, defaultValue);
-     }
-
-     else
-       filters.first = filters.second = boost::shared_ptr<CFilter>(new CPassThroughFilter(gc));
-
-     fieldRef->getInstantDataFilter()->connectOutput(filters.first, 0);
-
-     return filters.second;
-   }
+     boost::shared_ptr<COutputPin> CField::getFieldReference(CGarbageCollector& gc)
+     {
+       if (instantDataFilter || field_ref.isEmpty())
+         ERROR("COutputPin* CField::getFieldReference(CGarbageCollector& gc)",
+               "Impossible to get the field reference for a field which has already been parsed or which does not have a field_ref.");
+
+       CField* fieldRef = CField::get(field_ref);
+       fieldRef->buildFilterGraph(gc, false);
+
+       std::pair<boost::shared_ptr<CFilter>, boost::shared_ptr<CFilter> > filters;
+       // Check if a spatial transformation is needed
+       if (grid && grid != fieldRef->grid && grid->hasTransform())
+       {
+         double defaultValue = !default_value.isEmpty() ? default_value : 0.0;
+         filters = CSpatialTransformFilter::buildFilterGraph(gc, fieldRef->grid, grid, defaultValue);
+       }
+       else
+         filters.first = filters.second = boost::shared_ptr<CFilter>(new CPassThroughFilter(gc));
+
+       fieldRef->getInstantDataFilter()->connectOutput(filters.first, 0);
+
+       return filters.second;
+     }
 
    /*!
@@ -908,5 +985,5 @@
    boost::shared_ptr<COutputPin> CField::getSelfReference(CGarbageCollector& gc)
    {
-     if (instantDataFilter || content.empty())
+     if (instantDataFilter || !hasExpression())
        ERROR("COutputPin* CField::getSelfReference(CGarbageCollector& gc)",
              "Impossible to add a self reference to a field which has already been parsed or which does not have an expression.");
@@ -917,15 +994,19 @@
        {
          if (!serverSourceFilter)
-           serverSourceFilter = boost::shared_ptr<CSourceFilter>(new CSourceFilter(grid,
-                                                                                   freq_offset.isEmpty() ? NoneDu : freq_offset));
-
+           serverSourceFilter = boost::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid,
+                                                                                   freq_offset.isEmpty() ? NoneDu : freq_offset,
+                                                                                   true));
          selfReferenceFilter = serverSourceFilter;
        }
        else if (!field_ref.isEmpty())
-         selfReferenceFilter = getFieldReference(gc);
+       {
+         CField* fieldRef = CField::get(field_ref);
+         fieldRef->buildFilterGraph(gc, false);
+         selfReferenceFilter = fieldRef->getInstantDataFilter();
+       }
        else
        {
          if (!clientSourceFilter)
-           clientSourceFilter = boost::shared_ptr<CSourceFilter>(new CSourceFilter(grid));
+           clientSourceFilter = boost::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid));
 
          selfReferenceFilter = clientSourceFilter;
@@ -1126,5 +1207,6 @@
      else if (grid && grid->hasTransform() && !grid->isTransformed())
      {
-       grid->transformGrid(grid);
+       // Temporarily deactivate the self-transformation of grid
+       //grid->transformGrid(grid);
      }
    }
@@ -1325,5 +1407,5 @@
    }
 
-   void CField::sendAddAllVariables(const int srvPool)
+   void CField::sendAddAllVariables(CContextClient* client)
    {
      std::vector<CVariable*> allVar = getAllVariables();
@@ -1333,7 +1415,7 @@
      for (; it != itE; ++it)
      {
-       this->sendAddVariable((*it)->getId());
-       (*it)->sendAllAttributesToServer(srvPool);
-       (*it)->sendValue(srvPool);
+       this->sendAddVariable((*it)->getId(), client);
+       (*it)->sendAllAttributesToServer(client);
+       (*it)->sendValue(client);
      }
    }
@@ -1363,4 +1445,28 @@
    }
 
+   void CField::sendAddVariable(const string& id, CContextClient* client)
+   {
+      sendAddItem(id, (int)EVENT_ID_ADD_VARIABLE, client);
+    // CContext* context = CContext::getCurrent();
+
+    // if (!context->hasServer)
+    // {
+    //    CContextClient* client = context->client;
+
+    //    CEventClient event(this->getType(),EVENT_ID_ADD_VARIABLE);
+    //    if (client->isServerLeader())
+    //    {
+    //      CMessage msg;
+    //      msg << this->getId();
+    //      msg << id;
+    //      const std::list<int>& ranks = client->getRanksServerLeader();
+    //      for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+    //        event.push(*itRank,1,msg);
+    //      client->sendEvent(event);
+    //    }
+    //    else client->sendEvent(event);
+    // }
+   }
+
    void CField::sendAddVariableGroup(const string& id)
    {
@@ -1418,4 +1524,25 @@
    }
 
+   /*!
+    * Returns string arithmetic expression associated to the field.
+    * \return if content is defined return content string, otherwise, if "expr" attribute is defined, return expr string.
+    */
+   const string& CField::getExpression(void)
+   {
+     if (!expr.isEmpty() && content.empty())
+     {
+       content = expr;
+       expr.reset();
+     }
+
+     return content;
+   }
+
+   bool CField::hasExpression(void) const
+   {
+     return (!expr.isEmpty() || !content.empty());
+   }
+
+
    DEFINE_REF_FUNC(Field,field)
 } // namespace xios
Index: /XIOS/dev/dev_olga/src/node/field.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/field.hpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/node/field.hpp	(revision 1021)
@@ -16,4 +16,5 @@
 #include "transformation_enum.hpp"
 #include "variable.hpp"
+#include "context_client.hpp"
 
 
@@ -124,4 +125,5 @@
          boost::shared_ptr<COutputPin> getSelfReference(CGarbageCollector& gc);
          boost::shared_ptr<COutputPin> getTemporalDataFilter(CGarbageCollector& gc, CDuration outFreq);
+         boost::shared_ptr<COutputPin> getSelfTemporalDataFilter(CGarbageCollector& gc, CDuration outFreq);
 
 //         virtual void fromBinary(StdIStream& is);
@@ -139,9 +141,9 @@
         static bool dispatchEvent(CEventServer& event);
         void sendUpdateData(const CArray<double,1>& data);
-        void sendUpdateData(const CArray<double,1>& data, const int srvPool);
+        void sendUpdateData(const CArray<double,1>& data, CContextClient* client);
         static void recvUpdateData(CEventServer& event);
         void recvUpdateData(vector<int>& ranks, vector<CBufferIn*>& buffers);
         void writeField(void);
-        void sendReadDataRequest(void);
+        void sendReadDataRequest(const CDate& tsDataRequested);
         bool sendReadDataRequestIfNeeded(void);
         static void recvReadDataRequest(CEventServer& event);
@@ -169,5 +171,5 @@
         CVariableGroup* addVariableGroup(const string& id = "");
         void sendAddVariable(const string& id = "");
-        void sendAddVariable(const string& id, const int srvPool);
+        void sendAddVariable(const string& id, CContextClient* client);
         void sendAddVariableGroup(const string& id = "");
         static void recvAddVariable(CEventServer& event);
@@ -176,8 +178,10 @@
         void recvAddVariableGroup(CBufferIn& buffer);
         void sendAddAllVariables();
-        void sendAddAllVariables(const int srvPool);
-
+        void sendAddAllVariables(CContextClient* client);
 
         const std::vector<StdString>& getRefDomainAxisIds();
+
+        const string& getExpression(void);
+        bool hasExpression(void) const;
 
       public:
@@ -194,5 +198,6 @@
          bool isEOF;
          CDate lastlast_Write_srv, last_Write_srv, last_operation_srv;
-         CDate lastDataRequestedFromServer;
+         CDate lastDataRequestedFromServer, lastDataReceivedFromServer;
+         bool wasDataAlreadyReceivedFromServer;
 
          map<int,boost::shared_ptr<func::CFunctor> > foperation_srv;
@@ -204,6 +209,9 @@
          bool isReferenceSolved;
          std::vector<StdString> domAxisScalarIds_;
-         bool isReadDataRequestPending;
          bool useCompressedOutput;
+
+         // Two variables to identify the time_counter meta data written in file, which has no time_counter
+         bool hasTimeInstant;
+         bool hasTimeCentered;
 
          DECLARE_REF_FUNC(Field,field)
Index: /XIOS/dev/dev_olga/src/node/field_impl.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/field_impl.hpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/node/field_impl.hpp	(revision 1021)
@@ -20,5 +20,5 @@
     if (clientSourceFilter)
       clientSourceFilter->streamData(CContext::getCurrent()->getCalendar()->getCurrentDate(), _data);
-    else if (!field_ref.isEmpty() || !content.empty())
+    else if (instantDataFilter)
       ERROR("void CField::setData(const CArray<double, N>& _data)",
             << "Impossible to receive data from the model for a field [ id = " << getId() << " ] with a reference or an arithmetic operation.");
Index: /XIOS/dev/dev_olga/src/node/file.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/file.cpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/node/file.cpp	(revision 1021)
@@ -14,5 +14,4 @@
 #include "type.hpp"
 #include "xios_spl.hpp"
-#include "context_client.hpp"
 #include "mpi.hpp"
 
@@ -376,5 +375,4 @@
          {
            middlePart=filename.substr(pos1,pos2-pos1) ;
-           cout<<pos2<<endl ;
            pos2+=strEndDate.size() ;
            lastPart=filename.substr(pos2,filename.size()-pos2) ;
@@ -746,5 +744,5 @@
      int size = this->enabledFields.size();
      for (int i = 0; i < size; ++i)
-       this->enabledFields[i]->sendReadDataRequest();
+       this->enabledFields[i]->sendReadDataRequest(CContext::getCurrent()->getCalendar()->getCurrentDate());
    }
 
@@ -822,4 +820,14 @@
    {
      return vVariableGroup->createChildGroup(id);
+   }
+
+   void CFile::setContextClient(CContextClient* newContextClient)
+   {
+     client = newContextClient;
+   }
+
+   CContextClient* CFile::getContextClient()
+   {
+     return client;
    }
 
@@ -853,7 +861,7 @@
    }
 
-   void CFile::sendAddField(const string& id, const int srvPool)
-   {
-      sendAddItem(id, EVENT_ID_ADD_FIELD, srvPool);
+   void CFile::sendAddField(const string& id, CContextClient* client)
+   {
+      sendAddItem(id, EVENT_ID_ADD_FIELD, client);
     // CContext* context = CContext::getCurrent();
 
@@ -974,5 +982,5 @@
    }
 
-   void CFile::sendAddAllVariables(const int srvPool)
+   void CFile::sendAddAllVariables(CContextClient* client)
    {
      std::vector<CVariable*> allVar = getAllVariables();
@@ -982,7 +990,7 @@
      for (; it != itE; ++it)
      {
-       this->sendAddVariable((*it)->getId(), srvPool);
-       (*it)->sendAllAttributesToServer(srvPool);
-       (*it)->sendValue(srvPool);
+       this->sendAddVariable((*it)->getId(), client);
+       (*it)->sendAllAttributesToServer(client);
+       (*it)->sendValue(client);
      }
    }
@@ -1046,7 +1054,7 @@
    }
 
-   void CFile::sendAddVariable(const string& id, const int srvPool)
-   {
-      sendAddItem(id, (int)EVENT_ID_ADD_VARIABLE, srvPool);
+   void CFile::sendAddVariable(const string& id, CContextClient* client)
+   {
+      sendAddItem(id, (int)EVENT_ID_ADD_VARIABLE, client);
     // CContext* context = CContext::getCurrent();
 
@@ -1126,5 +1134,23 @@
    Remark: This function must be called AFTER all active (enabled) files have been created on the server side
    */
-   void CFile::sendEnabledFields()
+//   void CFile::sendEnabledFields()
+//   {
+//     size_t size = this->enabledFields.size();
+//     for (size_t i = 0; i < size; ++i)
+//     {
+//       CField* field = this->enabledFields[i];
+//       this->sendAddField(field->getId());
+//       field->sendAllAttributesToServer();
+//       field->sendAddAllVariables();
+//     }
+//   }
+
+   /*!
+     \brief Sending all active (enabled) fields from client to server.
+   Each field is identified uniquely by its string identity. Not only should we
+   send the id to server but also we need to send ids of reference domain and reference axis.
+   With these two id, it's easier to make reference to grid where all data should be written.
+   Remark: This function must be called AFTER all active (enabled) files have been created on the server side
+   */   void CFile::sendEnabledFields(CContextClient* client)
    {
      size_t size = this->enabledFields.size();
@@ -1132,21 +1158,10 @@
      {
        CField* field = this->enabledFields[i];
-       this->sendAddField(field->getId());
-       field->sendAllAttributesToServer();
-       field->sendAddAllVariables();
+       this->sendAddField(field->getId(), client);
+       field->sendAllAttributesToServer(client);
+       field->sendAddAllVariables(client);
      }
    }
 
-   void CFile::sendEnabledFields(const int srvPool)
-   {
-     size_t size = this->enabledFields.size();
-     for (size_t i = 0; i < size; ++i)
-     {
-       CField* field = this->enabledFields[i];
-       this->sendAddField(field->getId(), srvPool);
-       field->sendAllAttributesToServer(srvPool);
-       field->sendAddAllVariables(srvPool);
-     }
-   }
 
    /*!
Index: /XIOS/dev/dev_olga/src/node/file.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/file.hpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/node/file.hpp	(revision 1021)
@@ -11,4 +11,5 @@
 #include "attribute_enum.hpp"
 #include "attribute_enum_impl.hpp"
+#include "context_client.hpp"
 #include "mpi.hpp"
 
@@ -114,15 +115,17 @@
          CVariable* addVariable(const string& id = "");
          CVariableGroup* addVariableGroup(const string& id = "");
+         void setContextClient(CContextClient* newContextClient);
+         CContextClient* getContextClient();
 
          // Send info to server
-         void sendEnabledFields();
-         void sendEnabledFields(const int srvPool);
+//         void sendEnabledFields();
+         void sendEnabledFields(CContextClient* client);
          void sendAddField(const string& id = "");
-         void sendAddField(const string& id, const int srvPool);
+         void sendAddField(const string& id, CContextClient* client);
          void sendAddFieldGroup(const string& id = "");
-         void sendAddAllVariables();
-         void sendAddAllVariables(const int srvPool);
-         void sendAddVariable(const string& id = "");
-         void sendAddVariable(const string& id, const int srvPool);
+         void sendAddAllVariables();                        // to be removed (?)
+         void sendAddAllVariables(CContextClient* client);
+         void sendAddVariable(const string& id = "");         // to be removed (?)
+         void sendAddVariable(const string& id, CContextClient* client);
          void sendAddVariableGroup(const string& id = "");
 
@@ -169,4 +172,5 @@
          boost::shared_ptr<CDataInput> data_in;
          std::vector<CField*> enabledFields;
+         CContextClient* client;
 
       public:
Index: /XIOS/dev/dev_olga/src/node/grid.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/grid.cpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/node/grid.cpp	(revision 1021)
@@ -299,5 +299,7 @@
          }
 
-         this->isChecked = true;
+//         this->isChecked = true;
+         if (!(this->hasTransform() && !this->isTransformed()))
+          this->isChecked = true;
          return;
        }
@@ -316,5 +318,10 @@
           this->computeIndex();
        }
-       this->isChecked = true;
+//       this->isChecked = true;
+       if (!(this->hasTransform() && !this->isTransformed()))
+        this->isChecked = true;
+
+       if (!(this->hasTransform() && (!this->isGenerated())))
+        this->isChecked = true;
      }
    }
@@ -1094,4 +1101,5 @@
           }
 
+          storeIndex_fromSrv.insert(std::make_pair(rank, CArray<int,1>(outLocalIndexToServer)));
           listMsg.push_back(CMessage());
           listMsg.back() << getId( )<< isDataDistributed_ << isCompressible_ << listOutIndex.back();
@@ -1102,5 +1110,19 @@
       }
       else
+      {
+        const std::list<int>& ranks = client->getRanksServerNotLeader();
+        for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+        {
+          int rank = *itRank;
+          int nb = 1;
+          storeIndex_fromSrv.insert(std::make_pair(rank, CArray<int,1>(nb)));
+          CArray<int, 1>& outLocalIndexToServer = storeIndex_fromSrv[rank];
+          for (int k = 0; k < nb; ++k)
+          {
+            outLocalIndexToServer(k)  = 0;
+          }
+        }
         client->sendEvent(event);
+      }
     }
   }
@@ -1136,9 +1158,9 @@
           }
 
-          //int nbClient = client->clientSize; // This stupid variable signals the servers the number of client connect to them
           const std::list<int>& ranks = client->getRanksServerLeader();
           for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
           {
             storeIndex_toSrv.insert(std::make_pair(*itRank, CArray<int,1>(outLocalIndexToServer)));
+            storeIndex_fromSrv.insert(std::make_pair(*itRank, CArray<int,1>(outLocalIndexToServer)));
             listOutIndex.push_back(CArray<size_t,1>(outGlobalIndexOnServer));
 
@@ -1151,5 +1173,19 @@
         }
         else
-          client->sendEvent(event);
+        {
+           int indexSize = globalLocalIndexSendToServer.size();
+           CArray<int,1> outLocalIndexToServer(indexSize);
+           for (int idx = 0; itIndex != iteIndex; ++itIndex, ++idx)
+           {
+             outLocalIndexToServer(idx) = itIndex->second;
+           }
+
+           const std::list<int>& ranks = client->getRanksServerNotLeader();
+           for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+           {
+             storeIndex_fromSrv.insert(std::make_pair(*itRank, CArray<int,1>(outLocalIndexToServer)));
+           }
+           client->sendEvent(event);
+         }
       }
       else
@@ -1177,6 +1213,6 @@
         }
 
-//        for (int ns = 0; ns < connectedServerRank_.size(); ++ns)
-        for (int ns = 0; ns < client->serverSize; ++ns)
+        for (int ns = 0; ns < connectedServerRank_.size(); ++ns)
+//        for (int ns = 0; ns < client->serverSize; ++ns)
         {
           rank = connectedServerRank_[ns];
@@ -1197,4 +1233,5 @@
           }
 
+          storeIndex_fromSrv.insert(make_pair(rank, CArray<int,1>(outLocalIndexToServer)));
           listMsg.push_back(CMessage());
           listMsg.back() << getId() << isDataDistributed_ << isCompressible_ << listOutIndex.back();
Index: /XIOS/dev/dev_olga/src/node/grid.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/grid.hpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/node/grid.hpp	(revision 1021)
@@ -221,4 +221,5 @@
 
          map<int, CArray<int, 1> > storeIndex_toSrv;
+         map<int, CArray<int, 1> > storeIndex_fromSrv;
          map<int,int> nbSenders;
 
Index: /XIOS/dev/dev_olga/src/node/interpolate_domain.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/interpolate_domain.cpp	(revision 1020)
+++ /XIOS/dev/dev_olga/src/node/interpolate_domain.cpp	(revision 1021)
@@ -47,4 +47,46 @@
              << "Please define a correct one") ;
     }
+
+    if (this->mode.isEmpty()) this->mode.setValue(mode_attr::compute);
+    if (this->write_weight.isEmpty()) this->write_weight.setValue(false);
+
+    StdString weightFile;
+    switch (this->mode)
+    {
+      case mode_attr::read:
+        if (this->file.isEmpty())
+        {
+          if (!this->write_weight)
+            ERROR("void CInterpolateDomain::checkValid(CDomain* domainSrc)",
+                 << "Read mode is activated but there is no file specified." << std::endl
+                 << "Please define a correct file containing interpolation weights with option 'file'. ");
+        }
+        else
+        {
+          weightFile = this->file;
+          ifstream f(weightFile.c_str());
+          if (!f.good())
+            ERROR("void CInterpolateDomain::checkValid(CDomain* domainSrc)",
+                  << "Read mode is activated but file "  << weightFile << " doesn't exist." << std::endl
+                  << "Please check this file ");
+        }
+        break;
+      case mode_attr::compute:
+        break;
+      case mode_attr::read_or_compute:
+        if (!this->file.isEmpty() && !this->write_weight)
+        {
+          weightFile = this->file;
+          ifstream f(weightFile.c_str());
+          if (!f.good())
+            ERROR("void CInterpolateDomain::checkValid(CDomain* domainSrc)",
+                  << "read_or_compute mode is activated but file "  << weightFile << " doesn't exist." << std::endl
+                  << "Please check this file ");
+        }
+        break;
+      default:
+        break;
+    }
+
   }
 
